//---------------------------------------------------------------------------

#ifndef Basic4GLMainFormH
#define Basic4GLMainFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
#include <ToolWin.hpp>
//---------------------------------------------------------------------------
#include "FileEditorFrame.h"
#include "TomComp.h"
#include "glSpriteEngine.h"
#include "EmbeddedFiles.h"
#include <ActnList.hpp>
#include <AppEvnts.hpp>
#include <vector>

typedef std::vector<TFileEditor *> FileEditorVector;
enum RunMode { RM_STOPPED, RM_PAUSED, RM_RUNNING };

#define VMSTEPS 1000

class TMainForm : public TForm
{
__published:	// IDE-managed Components
    TTabControl *Tabs;
    TToolBar *ToolBar1;
    TMainMenu *Menu;
    TMenuItem *Program1;
    TMenuItem *Basic4GL1;
    TImageList *Images;
    TToolButton *ToolButton1;
    TActionList *Actions;
    TAction *GoStopAction;
    TMenuItem *Go1;
    TStatusBar *Status;
    TImageList *ImagesBright;
    TImageList *ImagesGray;
    TAction *ExitAction;
    TMenuItem *N1;
    TMenuItem *N2;
    TAction *NewAction;
    TAction *OpenAction;
    TAction *SaveAction;
    TToolButton *ToolButton2;
    TToolButton *ToolButton3;
    TToolButton *ToolButton4;
    TToolButton *ToolButton5;
    TAction *SaveAsAction;
    TMenuItem *N3;
    TMenuItem *New1;
    TMenuItem *Open1;
    TMenuItem *Save1;
    TMenuItem *SaveAs1;
    TAction *PlayAction;
    TAction *StepOverAction;
    TAction *StepIntoAction;
    TAction *StepOutOfAction;
    TToolButton *ToolButton6;
    TToolButton *ToolButton7;
    TToolButton *ToolButton8;
    TToolButton *ToolButton9;
    TToolButton *ToolButton10;
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall GoStopActionExecute(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall ExitActionExecute(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall NewActionExecute(TObject *Sender);
    void __fastcall OpenActionExecute(TObject *Sender);
    void __fastcall SaveActionExecute(TObject *Sender);
private:	// User declarations

    // Compiler and VM
    TomBasicCompiler    m_comp;
    TomVM               m_vm;

    FileOpener          m_files;

    // Editors
    FileEditorVector m_fileEditors;

    // State
    RunMode m_runMode;

    // OpenGL window
    glTextGridWindow    *m_glWin;
    glTextGrid          *m_glText;

    void ResetProject();
    void ShowEditor(unsigned int index);
    void LoadParser(TFileEditor *editor);       // Load editor text into parser
    void PutCursor(int line, int col);
    void PutCursorAtIP();
    void SynchroniseTabs();
    bool CheckModified();

    // Program control
    bool Compile();
    void Run();
    void Stop();
    void Continue();
    void Pause();

    void SetupForRun();
    void ActivateForContinue();
    void DeactivateForStop();
    void InitLibraries();
    void ShutDownLibraries();

    void DriveVM();

public:		// User declarations
    __fastcall TMainForm(TComponent* Owner);
    void RunApplication();
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
