//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "NetworkEventView.h"
#include "NetMiscRoutines.h"
using namespace NetLib4Games;
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TNetEventForm *NetEventForm;

static void LogNetEvent (std::string text) {
    NetEventForm->Log (text);
}

//---------------------------------------------------------------------------
__fastcall TNetEventForm::TNetEventForm(TComponent* Owner)
    : TForm(Owner), m_logging (false)
{
    SetNetLogger (LogNetEvent);
    Clear ();
}
//---------------------------------------------------------------------------
void TNetEventForm::Log (std::string event) {
    m_netLogLock.Lock ();
        if (m_logging) {
            m_netLogBuffer.push_back (IntToString (GetCurrentThreadId ()) + ", " + IntToString (GetTickCount ()) + ": " + event);
        }
    m_netLogLock.Unlock ();
}
//---------------------------------------------------------------------------
void __fastcall TNetEventForm::Timer1Timer(TObject *Sender)
{
    if (Visible) {

        bool change = false;

        // Copy items from buffer
        m_netLogLock.Lock ();
            while (!m_netLogBuffer.empty ()) {

                // Change has occurred
                change = true;

                // Copy lines from buffer
                m_netLog [m_netLogEnd] = m_netLogBuffer.front ().c_str ();
                m_netLogBuffer.pop_front ();

                // Update markers
                m_netLogEnd = (m_netLogEnd + 1) % 500;
                if (m_netLogEnd == m_netLogStart)
                    m_netLogStart = (m_netLogStart + 1) % 500;
            }
        m_netLogLock.Unlock ();

        if (change)
            Grid->Invalidate ();
    }
}
//---------------------------------------------------------------------------

void __fastcall TNetEventForm::LoggingCheckClick(TObject *Sender)
{
    m_netLogLock.Lock ();
        m_logging = LoggingCheck->Checked;
    m_netLogLock.Unlock ();
}
//---------------------------------------------------------------------------
void __fastcall TNetEventForm::GridDrawCell(TObject *Sender, int ACol,
      int ARow, TRect &Rect, TGridDrawState State)
{
    int index = (m_netLogStart + ARow) % 500;
    Grid->Canvas->TextOut (Rect.left + 2, Rect.top + 2, m_netLog [index]);
}
//---------------------------------------------------------------------------

void __fastcall TNetEventForm::ClearButtonClick(TObject *Sender)
{
    Clear ();
}
//---------------------------------------------------------------------------
void TNetEventForm::Clear () {
    for (int i = 0; i < 500; i++)
        m_netLog [i] = "";
    m_netLogStart   = 0;
    m_netLogEnd     = 1;
    Grid->Invalidate ();
}
//---------------------------------------------------------------------------


void __fastcall TNetEventForm::Copy1Click(TObject *Sender)
{
    AnsiString text = "";
    for (int i = m_netLogStart; i != m_netLogEnd; i = (i + 1) % 500)
        text += m_netLog [i] + "\r\n";

    Clipboard ()->AsText = text;
}
//---------------------------------------------------------------------------

void __fastcall TNetEventForm::Clear1Click(TObject *Sender)
{
    Clear ();
}
//---------------------------------------------------------------------------

