/*	Created 11-Apr-2005: Thomas Mulgrew (tmulgrew@slingshot.co.nz)

	IMPORTANT:

	This is a DUMMY replacement for the real TomComp.h file that's used 
	in the Basic4GL compiler, for use by standalone exe stubs ONLY.
	
	It defines a DUMMY compiler object which can be passed to the function
	library initialisation code. The object simply passes the registration
	through to the virtual machine, and discards any compiler specific 
	information.
*/

#ifndef _TomComp_h
#define _TomComp_h
#include "TomVM.h"

///////////////////////////////////////////////////////////////////////////////
//	compParamTypeList
//
///	Dummy compiler parameter list object.

struct compParamTypeList {
	compParamTypeList () { ; }
	compParamTypeList (compParamTypeList& list) { ; }
	compParamTypeList& operator<< (vmBasicValType valType) { return *this; }
	compParamTypeList& operator<< (vmValType valType) { return *this; }
};

typedef bool (*compUnOperExt)(  vmValType& regType,     // IN: Current type in register.                                                        OUT: Required type cast before calling function
                                vmOpCode oper,          // IN: Operator being applied
                                int& operFunction,      // OUT: Index of VM_CALL_OPERATOR_FUNC function to call
                                vmValType& resultType,  // OUT: Resulting value type
                                bool& freeTempData);    // OUT: Set to true if temp data needs to be freed
typedef bool (*compBinOperExt)( vmValType& regType,     // IN: Current type in register.                                                        OUT: Required type cast before calling function
                                vmValType& reg2Type,    // IN: Current type in second register (operation is reg2 OP reg1, e.g reg2 + reg1):    OUT: Required type cast before calling function
                                vmOpCode oper,          // IN: Operator being applied
                                int& operFunction,      // OUT: Index of VM_CALL_OPERATOR_FUNC function to call
                                vmValType& resultType,  // OUT: Resulting value type
                                bool& freeTempData);    // OUT: Set to true if temp data needs to be freed

///////////////////////////////////////////////////////////////////////////////
//	TomBasicCompiler
//
///	Dummy compiler object.

class TomBasicCompiler {
private:
	TomVM	&m_vm;

public:
	TomBasicCompiler (TomVM& vm) : m_vm (vm) { ; }

	// Methods used by function registration
	TomVM& VM () { return m_vm; }
    void AddFunction (  std::string         name,
                        vmFunction          func,
                        compParamTypeList   params,
                        bool                brackets,
                        bool                isFunction,
                        vmValType           returnType,
                        bool                timeshare = false,
                        bool                freeTempData = false) {
		m_vm.AddFunction (func);
	}
    void AddConstant (std::string name, std::string s)    { ; }
    void AddConstant (std::string name, int i)            { ; }
    void AddConstant (std::string name, unsigned int i)   { ; }
    void AddConstant (std::string name, float r)          { ; }
    void AddConstant (std::string name, double r)         { ; }
    void AddUnOperExt  (compUnOperExt e)    { ; }
    void AddBinOperExt (compBinOperExt e)   { ; }
};

#endif